#!/bin/sh

COLOR="\e[32m"
RESET="\e[0m"

finish_installation() {
    EPUBLICKEY=$(grep cppubkey /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php | sed 's/.*"\([a-zA-Z0-9]*\)".*/\1/')   #"
    EPRIVATEKEY=$(grep cpprivkey /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php | sed 's/.*"\([a-zA-Z0-9]*\)".*/\1/') #"
    ESALT=$(grep "\$cpsalt" /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php | sed 's/.*"\([a-zA-Z0-9]*\)".*/\1/')      #"
    
    if [[ ! -n "${ESALT/[ ]*\n/}" ]]; then
	ESALT=$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | head -c 32)
    fi

    echo -e "Configure CryptoPhoto plugin (see ${COLOR}https://cryptophoto.com/info/admin$RESET on how to aquire API keys)"

    read -p "Enter CryptoPhoto Public API key [$EPUBLICKEY]: " PUBLICKEY
    read -p "Enter CryptoPhoto Private API key [$EPRIVATEKEY]: " PRIVATEKEY

    echo "A SALT (random string) is needed to hash your users IDs. Once set, it must not be changed."
    read -p "Enter SALT[$ESALT]: " SALT

    if [[ ! -n "${PUBLICKEY/[ ]*\n/}" ]]; then
        PUBLICKEY=$EPUBLICKEY
    fi

    if [[ ! -n "${PRIVATEKEY/[ ]*\n/}" ]]; then
        PRIVATEKEY=$EPRIVATEKEY
    fi

    if [[ ! -n "${SALT/[ ]*\n/}" ]]; then
        SALT=$ESALT
    fi

    echo -e "Updating $COLOR\$cppubkey$RESET in $COLOR/opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php$RESET."
    sed -i "s/\(cppubkey.*= \"\).*\"/\1${PUBLICKEY}\"/" /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php

    echo -e "Updating $COLOR\$cpprivkey$RESET in $COLOR/opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php$RESET."
    sed -i "s/\(cpprivkey.*= \"\).*\"/\1${PRIVATEKEY}\"/" /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php

    echo -e "Updating $COLOR\$cpsalt$RESET in $COLOR/opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php$RESET."
    sed -i "s/\(cpsalt.*= \"\).*\"/\1${SALT}\"/" /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php

    read -p "Enable CryptoPhoto service (y/n): " ENABLE

    if [[ $ENABLE =~ ^[Yy]$ ]]; then
        echo -e "Changing ${COLOR}ENABLE_CRYPTOPHOTO$RESET to ${COLOR}1$RESET in $COLOR/opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php$RESET."
        sed -i "s/define(\"ENABLE_CRYPTOPHOTO\", 0)/define(\"ENABLE_CRYPTOPHOTO\", 1)/" /opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php
    else
        echo -e "You will need to change ${COLOR}ENABLE_CRYPTOPHOTO$RESET to ${COLOR}1$RESET in $COLOR/opt/CPcvpn-R80/phpincs/CryptoPhotoConf.php$RESET when you are ready to use CryptoPhoto Services."
    fi
}

restart_blades() {
    read -p "Restart Mobile Access blade services? (y/n): " RESTART

    if [[ $RESTART =~ ^[Yy]$ ]]; then
        echo "Restarting Mobile Access blade services..."
        /opt/CPcvpn-R80/bin/cvpnrestart
    else
        echo -e "You will need to execute ${COLOR}/opt/CPcvpn-R80/bin/cvpnrestart$RESET in order for the new changes to be applied."
    fi
}

finish_installation
restart_blades

echo "Configuration finished."